<?php

namespace Drupal\toolshed\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * Defines the Toolshed third party plugins for entity configurations.
 *
 * Plugin Namespace: Plugin\Toolshed\ThirdPartyConfig.
 *
 * @see \Drupal\Component\Annotation\Plugin
 * @see \Drupal\toolshed\Plugin\ThirdPartyConfigInterface
 * @see \Drupal\toolshed\Plugin\ThirdPartyConfigPluginManager
 *
 * @ingroup toolshed_third_party_config_plugins
 *
 * @Annotation
 */
class ToolshedThirdPartyConfig extends Plugin {

  /**
   * The globally unique plugin ID / machine name.
   *
   * @var string
   */
  public $id;

  /**
   * The human friendly name for admin configuration forms.
   *
   * @var \Drupal\Core\Annotation\Translation
   *
   * @ingroup plugin_translatable
   */
  public $label;

  /**
   * The label to use as the third party settings element.
   *
   * @var string
   */
  public $name;

  /**
   * The weight to apply to the third party settings in the entity form.
   *
   * A default is added to the plugin definition by the plugin manager.
   *
   * @var int
   */
  public $weight;

  /**
   * An array of the ConfigEntityInterfaces ID that this plugin applies to.
   *
   * @var string[]
   */
  public $entity_types;

}
